> For the complete documentation index, see [llms.txt](https://docs.fluentd.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fluentd.org/service_discovery/file.md).

# file

The `file` service discovery plugin updates the targets by reading the local file. YAML and JSON are the allowed file formats.

## Example Configuration

Here is an example with `out_forward` updating targets by sending data:

```
<match pattern>
  @type forward

  <service_discovery>
    @type file
    path "/etc/fluentd/sd.yaml"
  </service_discovery>
</source>
```

Here is an example of target list file (`/etc/fluentd/sd.yaml`):

```
- 'host': 127.0.0.1
  'port': 24224
  'weight': 1
  'name': server1
- 'host': 127.0.0.1
  'port': 24225
  'weight': 1
  'name': server2
```

## Parameters

### `@type`

The value must be `file`.

### `path`

| type   | default                 | version |
| ------ | ----------------------- | ------- |
| string | `'/etc/fluent/sd.yaml'` | 1.8.0   |

The path of the target list.

The `Content-Type` is determined by file extension i.e.:

* YAML: yaml, yml
* JSON: json

### `conf_encoding`

| type   | default   | version |
| ------ | --------- | ------- |
| string | `'utf-8'` | 1.8.0   |

The encoding of the configuration file.

### Parameters in Target List File

Each target has following parameters:

* `host`
* `name`
* `port`
* `shared_key`
* `username`
* `password`
* `standby`
* `weight`

#### `host`

| type   | default | version |
| ------ | ------- | ------- |
| string | `nil`   | 1.8.0   |

The IP address or hostname of the server. It is a required parameter.

#### `port`

| type    | default | version |
| ------- | ------- | ------- |
| integer |         | 1.8.0   |

The port number of the host. It is a required parameter.

#### `name`

| type   | default | version |
| ------ | ------- | ------- |
| string | `nil`   | 1.8.0   |

The name of the server.

#### `shared_key`

| type   | default | version |
| ------ | ------- | ------- |
| string | `nil`   | 1.8.0   |

The shared key per server.

#### `username`

| type   | default | version |
| ------ | ------- | ------- |
| string | `nil`   | 1.8.0   |

The username for authentication.

#### `password`

| type   | default | version |
| ------ | ------- | ------- |
| string | `nil`   | 1.8.0   |

The password for authentication.

#### `standby`

| type | default | version |
| ---- | ------- | ------- |
| bool | `nil`   | 1.8.0   |

#### `weight`

| type    | default | version |
| ------- | ------- | ------- |
| integer | 60      | 1.8.0   |

If this article is incorrect or outdated, or omits critical information, please [let us know](https://github.com/fluent/fluentd-docs-gitbook/issues?state=open). [Fluentd](http://www.fluentd.org/) is an open-source project under [Cloud Native Computing Foundation (CNCF)](https://cncf.io/). All components are available under the Apache 2 License.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fluentd.org/service_discovery/file.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
